﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SampleGridData
{
    public class ClassA : Observable
    {

        string p1;

        public string Property1
        {

            get { return p1; }

            set
            {

                p1 = value;

                RaisePropertyChangedEvent("Property1");

            }

        }



        ClassB p2;

        public ClassB Property2
        {

            get { return p2; }

            set
            {

                if (p2 != null)

                    p2.PropertyChanged -= OnProperty2Changed;



                p2 = value;

                this.RaisePropertyChangedEvent("Property2");

                if (p2 != null)

                    p2.PropertyChanged += OnProperty2Changed;

            }

        }



        string p2r;

        public string Propert2Representation
        {

            get { return p2r; }

            set
            {

                p2r = value;

                RaisePropertyChangedEvent("Propert2Representation");

            }

        }



        void OnProperty2Changed(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {

            this.RaisePropertyChangedEvent("Property2");

            this.Propert2Representation = Property2.ToString();

        }



        public override string ToString()
        {

            return "Class A";

        }

    }



    public class ClassB : Observable
    {

        public int Property1
        {
            get { return p1; }
            set
            {
                p1 = value; 
                RaisePropertyChangedEvent("Property1");
            }
        }
        private int p1;

        public override string ToString()
        {

            return "Class B: " + Property1;

        }

    }


}
