﻿using System.Collections.ObjectModel;
using System;



namespace SampleGridData
{
    public class ViewModel
    {
        public ViewModel()
        {
            Items = new ObservableCollection<ClassA>();
            for (int i = 0; i < 100; i++)
            {
                Items.Add(new ClassA()
                {
                    Property1 = "Random Number: " + i,
                    Property2 = new ClassB() { Property1 = i },
                    Propert2Representation = "Item " + i
                });
            }


            System.Threading.TimerCallback cb = new System.Threading.TimerCallback(ProcessTimerEvent);
            timer = new System.Threading.Timer(cb, Items, new TimeSpan(0, 0, 4), new TimeSpan(0, 0, 2)); 

        }

        public ObservableCollection<ClassA> Items { get; set; }

        private System.Threading.Timer timer;

        private static Random randomNumber = new Random();
        private static void ProcessTimerEvent(object obj)
        {
            ObservableCollection<ClassA> items = obj as ObservableCollection<ClassA>;
            if (items != null)
            {
                foreach (var item in items)
                {
                    item.Property1 = "Testing: Item " + (Int32)randomNumber.Next(Int32.MinValue, Int32.MaxValue);
                    item.Property2.Property1++;
                }
            }
        }

    }
}
